unit untMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, untPeFile, Menus, ComCtrls;

type
  TfrmMain = class(TForm)
    Button1: TButton;
    lvSections: TListView;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

const
 sFormatStr                = '%2.8x';
 sFormatStr2               = '%2.4x';

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  Pe: TPeFile;
  x: Word;
  ListItem: TListItem;
begin
  Pe := TPeFile.Create;
  if Pe.LoadFromFile(Application.ExeName) then
  begin
    lvSections.Clear;
    lvSections.Items.BeginUpdate;
    for x := Low(Pe.ImageSections) to High(Pe.ImageSections) do
    begin
      ListItem := lvSections.Items.Add;
      ListItem.Caption := Pe.SectionToString(Pe.ImageSections[x]);
      ListItem.SubItems.Add(Format(sFormatStr, [Pe.ImageSections[x].VirtualAddress]));
      ListItem.SubItems.Add(Format(sFormatStr, [Pe.ImageSections[x].Misc.VirtualSize]));
      ListItem.SubItems.Add(Format(sFormatStr, [Pe.ImageSections[x].PointerToRawData]));
      ListItem.SubItems.Add(Format(sFormatStr, [Pe.ImageSections[x].SizeOfRawData]));
      ListItem.SubItems.Add(Format(sFormatStr, [Pe.ImageSections[x].Characteristics]));
    end;
    Pe.DumpSection(Pe.GetResourceSection, 'res.bin');
    Pe.DumpSection(Pe.GetDataSection, 'data.bin');
    lvSections.Items.EndUpdate;
  end;
  Pe.Free;
end;

end.
